package CS561A1.Farris;

public class AStarSearch implements Comparable<AStarSearch>{
	public int[][] board = new int[3][3];
	public int functionValue;
	public int heuristicValue;
	public int totalCost;
	public String move;
	
	public AStarSearch(int[][] board){
		this.board = board;
		this.functionValue = 1;
		this.heuristicValue = 0;
		this.totalCost = this.functionValue + this.heuristicValue;
		this.move = null;
	}
	public AStarSearch(int[][] temp_board, String movement){
		this.board = temp_board;
		this.functionValue = 1;
		this.heuristicValue = 0;
		this.totalCost = 0;
		this.move = movement;
	}
	
	public int compareTo(AStarSearch node) {
		return this.totalCost - node.totalCost;
	}
	
	public static int Heuristic1(int[][] board){
		int misplaced = 0;
		if(board[0][0] != 1){
			misplaced++;
		}
		if(board[0][1] != 2){
			misplaced++;
		}
		if(board[0][2] != 3){
			misplaced++;
		}
		if(board[1][0] != 4){
			misplaced++;
		}
		if(board[1][1] != 5){
			misplaced++;
		}
		if(board[1][2] != 6){
			misplaced++;
		}
		if(board[2][0] != 7){
			misplaced++;
		}
		if(board[2][1] != 8){
			misplaced++;
		}


		return misplaced;
	}
	
	public static int Heuristic2(int[][] board) {
		int manhattan = 0;
		
		
		return manhattan;
	}
	
	public Boolean IsGoal(){
		if((this.board[0][0] == 1) && (this.board[0][1]==2) && (this.board[0][2] == 3)
			&& (this.board[1][0] == 4) && (this.board[1][1] == 5) && (this.board[1][2]== 6)
			&& (this.board[2][0] == 7) && (this.board[2][1] == 8) && (this.board[2][2] == 0))
		{
			return true;
		}
		else {
			return false;
		}
	}
			

}
